//+------------------------------------------------------------------
//|QQE Advanced_alerts_arrows_v2 with JMA
//|Mod of Boxter
//|http://www.forex-tsd.com/manual-trading-systems-indicators/3580-elite-indicators-396.html#post415267
//|0 - "regular" rsi
//|1 - Wilder's rsi
//|2 - rsx
//|3 - Cuttler rsi
//|
//+------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  DeepSkyBlue
#property indicator_color2  DeepSkyBlue
#property indicator_color3  Red
#property indicator_width1  2
#property indicator_style2  STYLE_DOT
#property indicator_style3  STYLE_DOT

extern string TimeFrame          = "Current time frame";
extern int    RsiPeriod          = 14;
extern int    RsiPrice           = PRICE_CLOSE;
/*
PRICE_CLOSE; 0; Close price. 
PRICE_OPEN; 1; Open price. 
PRICE_HIGH; 2; High price. 
PRICE_LOW; 3; Low price. 
PRICE_MEDIAN; 4; Median price, (high+low)/2. 
PRICE_TYPICAL; 5; Typical price, (high+low+close)/3. 
PRICE_WEIGHTED; 6; Weighted close price, (high+low+close+close)/4. 
*/
extern int    RsiSmoothingFactor = 5;
extern string RsiMethodT = "---0=rsi,1=Wilders rsi,2=rsx,3=Cuttler RSI---------------";
extern int    RsiMethod          = 1;
extern string MaMethodT = "---0=SMA;1=EMA;2=SMMA;3=LWMA;4=JMA---------------";
extern int    MaMethod           = 4; 
extern string MaPeriodT = "---0=No difference between MAs------------------------";
extern int    MaPeriod           = 0;
extern int    JMAphase=0;
extern double WPFast             = 2.618;
extern double WPSlow             = 4.236;
extern bool   Interpolate        = true;

extern bool   alertsOn           = false;
extern bool   alertsOnCurrent    = true;
extern bool   alertsMessage      = true;
extern bool   alertsSound        = false;
extern bool   alertsEmail        = false;

extern bool   ShowArrows         = true;
extern string arrowsIdentifier   = "QQE Arrows";
extern color  arrowsUpColor      = LimeGreen;
extern color  arrowsDnColor      = Red;

double RsiMa[];
double TrendFast[];
double TrendSlow[];
double trend[];

string indicatorFileName;
bool   calculateValue;
bool   returnBars;
int    timeFrame;

//+------------------------------------------------------------------+
//|   Init Function                                                               |
//+------------------------------------------------------------------+

int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,RsiMa);     SetIndexLabel(0, "QQE");
   SetIndexBuffer(1,TrendSlow); SetIndexLabel(1, "QQE trend");
   SetIndexBuffer(2,TrendFast); SetIndexLabel(2, "QQE fast trend");
   SetIndexBuffer(3,trend);

   MaPeriod = MathMax(MaPeriod,1);
   indicatorFileName = WindowExpertName();
   returnBars        = TimeFrame=="returnBars";     if (returnBars)     return(0);
   calculateValue    = TimeFrame=="calculateValue"; if (calculateValue) return(0);
   timeFrame         = stringToTimeFrame(TimeFrame);

   IndicatorShortName(timeFrameToString(timeFrame)+" QQE advanced_alerts_arrows_v2 with JMA of "+getRsiName(RsiMethod)+" ("+RsiPeriod+","+RsiSmoothingFactor+")");
// RsiMethod = "rsi","Wilders rsi","rsx","Cuttler RSI"
   return(0);
}

int deinit() { if (!calculateValue && ShowArrows) deleteArrows(); return(0); }

//+------------------------------------------------------------------
//|  Start function                                      
//+------------------------------------------------------------------

double emas[][4];
#define iEma 0
#define iEmm 1
#define iEmf 2
#define iEms 3

int start(){
   int counted_bars=IndicatorCounted();
   int i,r,limit;
   double MAcalc; //new
   
   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
   limit = MathMin(Bars-counted_bars,Bars-1);
   if (returnBars) { RsiMa[0] = limit+1; return(0); }
   if (calculateValue || timeFrame == Period()){
      if (ArrayRange(emas,0) != Bars) ArrayResize(emas,Bars);  
      double tr,dv;
      double alpha1 = 2.0/(RsiSmoothingFactor+1.0);
      double alpha2 = 1.0/(RsiPeriod);
      for (i=limit, r=Bars-i-1; i>=0; i--,r++){  
      
      //Now MA and JMA are used:
         if (MaMethod<4)MAcalc=iMA(NULL,0,MaPeriod,0,MaMethod,RsiPrice,i);
         if (MaMethod==4)MAcalc=iCustom(NULL,0,"JMA",MaPeriod,JMAphase,0,i); //new       
         RsiMa[i]      = RsiMa[i+1] + alpha1*(iRsi(MAcalc,RsiPeriod,i,0,RsiMethod) - RsiMa[i+1]);
      //------------------------
         emas[r][iEma] = emas[r-1][iEma] + alpha2*(MathAbs(RsiMa[i+1]-RsiMa[i]) - emas[r-1][iEma]);
         emas[r][iEmm] = emas[r-1][iEmm] + alpha2*(emas[r][iEma]                - emas[r-1][iEmm]);
         emas[r][iEmf] = emas[r][iEmm]*WPFast;
         emas[r][iEms] = emas[r][iEmm]*WPSlow;

         tr = TrendSlow[i+1];
         dv = tr;
               if (RsiMa[i] < tr) { tr = RsiMa[i] + emas[r][iEms]; if ((RsiMa[i+1] < dv) && (tr > dv)) tr = dv; }
               if (RsiMa[i] > tr) { tr = RsiMa[i] - emas[r][iEms]; if ((RsiMa[i+1] > dv) && (tr < dv)) tr = dv; }
         TrendSlow[i] = tr;
         
         tr = TrendFast[i+1];
         dv = tr;
               if (RsiMa[i] < tr) { tr = RsiMa[i] + emas[r][iEmf]; if ((RsiMa[i+1] < dv) && (tr > dv)) tr = dv; }
               if (RsiMa[i] > tr) { tr = RsiMa[i] - emas[r][iEmf]; if ((RsiMa[i+1] > dv) && (tr < dv)) tr = dv; }
         TrendFast[i] = tr;
         
         trend[i] = trend[i+1];
               if (RsiMa[i] > TrendSlow[i] && RsiMa[i] > TrendFast[i]) trend[i] =  1; 
               if (RsiMa[i] < TrendSlow[i] && RsiMa[i] < TrendFast[i]) trend[i] = -1;
               if (!calculateValue) manageArrow(i); 
      }
      manageAlerts();
      return(0);
   }
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for(i=limit; i>=0; i--){
      int y = iBarShift(NULL,timeFrame,Time[i]);
      RsiMa[i]     = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RsiPeriod,RsiPrice,RsiSmoothingFactor,RsiMethod,MaMethod,MaPeriod,JMAphase,WPFast,WPSlow,0,y); //JMA adapted
      TrendSlow[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RsiPeriod,RsiPrice,RsiSmoothingFactor,RsiMethod,MaMethod,MaPeriod,JMAphase,WPFast,WPSlow,1,y); //JMA adapted
      TrendFast[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RsiPeriod,RsiPrice,RsiSmoothingFactor,RsiMethod,MaMethod,MaPeriod,JMAphase,WPFast,WPSlow,2,y); //JMA adapted
      trend[i]     = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RsiPeriod,RsiPrice,RsiSmoothingFactor,RsiMethod,MaMethod,MaPeriod,JMAphase,WPFast,WPSlow,3,y); //JMA adapted
         
      manageArrow(i);
      if (timeFrame <= Period() || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;
      if (!Interpolate) continue;
      datetime time = iTime(NULL,timeFrame,y);
      for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
      double factor = 1.0 / n;
      for(int k = 1; k < n; k++){
          RsiMa[i+k]     = k*factor*RsiMa[i+n]     + (1.0-k*factor)*RsiMa[i];
          TrendSlow[i+k] = k*factor*TrendSlow[i+n] + (1.0-k*factor)*TrendSlow[i];
          TrendFast[i+k] = k*factor*TrendFast[i+n] + (1.0-k*factor)*TrendFast[i];
      }               
   }   
   manageAlerts();
   return(0);
}

//+-------------------------------------------------------------------
//|   Others                                        
//+-------------------------------------------------------------------

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

int stringToTimeFrame(string tfs){
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

string timeFrameToString(int tf){
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

string StringUpperCase(string str){
   string   s = str;
   for (int length=StringLen(str)-1; length>=0; length--){
      int char = StringGetChar(s, length);
      if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
      else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

//+------------------------------------------------------------------
//|   "rsi","Wilders rsi","rsx","Cuttler RSI"                                             
//+------------------------------------------------------------------

string rsiMethodNames[] = {"rsi","Wilders rsi","rsx","Cuttler RSI"};
string getRsiName(int& method){
   int max = ArraySize(rsiMethodNames)-1;
      method=MathMax(MathMin(method,max),0); return(rsiMethodNames[method]);
}

double workRsi[][13];
#define _price  0
#define _change 1
#define _changa 2

double iRsi(double price, double period, int i, int instanceNo=0, int rsiMode=0){
   if (ArrayRange(workRsi,0)!=Bars) ArrayResize(workRsi,Bars);
      int z = instanceNo*13; 
      int r = Bars-i-1;
   
   workRsi[r][z+_price] = price;
   switch (rsiMode){
      case 0:
         double alpha = 1.0/period; 
         if (r<period)
            {
               int k; double sum = 0; for (k=0; k<period && (r-k-1)>=0; k++) sum += MathAbs(workRsi[r-k][z+_price]-workRsi[r-k-1][z+_price]);
                  workRsi[r][z+_change] = (workRsi[r][z+_price]-workRsi[0][z+_price])/MathMax(k,1);
                  workRsi[r][z+_changa] =                                         sum/MathMax(k,1);
            }
         else
            {
               double change = workRsi[r][z+_price]-workRsi[r-1][z+_price];
                               workRsi[r][z+_change] = workRsi[r-1][z+_change] + alpha*(        change  - workRsi[r-1][z+_change]);
                               workRsi[r][z+_changa] = workRsi[r-1][z+_changa] + alpha*(MathAbs(change) - workRsi[r-1][z+_changa]);
            }
         if (workRsi[r][z+_changa] != 0)
               return(50.0*(workRsi[r][z+_change]/workRsi[r][z+_changa]+1));
         else  return(50.0);
      
      case 1 :
         workRsi[r][z+1] = iSmma(0.5*(MathAbs(workRsi[r][z+_price]-workRsi[r-1][z+_price])+(workRsi[r][z+_price]-workRsi[r-1][z+_price])),0.5*(period-1),Bars-i-1,0);
         workRsi[r][z+2] = iSmma(0.5*(MathAbs(workRsi[r][z+_price]-workRsi[r-1][z+_price])-(workRsi[r][z+_price]-workRsi[r-1][z+_price])),0.5*(period-1),Bars-i-1,1);
         if((workRsi[r][z+1] + workRsi[r][z+2]) != 0) 
               return(100.0 * workRsi[r][z+1]/(workRsi[r][z+1] + workRsi[r][z+2]));
         else  return(50);

      case 2 :     
         double Kg = (3.0)/(2.0+period), Hg = 1.0-Kg;
         if (r<period) { for (k=1; k<13; k++) workRsi[r][k+z] = 0; return(50); }  
      
         double mom = workRsi[r][_price+z]-workRsi[r-1][_price+z];
         double moa = MathAbs(mom);
         for (k=0; k<3; k++)
         {
            int kk = k*2;
            workRsi[r][z+kk+1] = Kg*mom                + Hg*workRsi[r-1][z+kk+1];
            workRsi[r][z+kk+2] = Kg*workRsi[r][z+kk+1] + Hg*workRsi[r-1][z+kk+2]; mom = 1.5*workRsi[r][z+kk+1] - 0.5 * workRsi[r][z+kk+2];
            workRsi[r][z+kk+7] = Kg*moa                + Hg*workRsi[r-1][z+kk+7];
            workRsi[r][z+kk+8] = Kg*workRsi[r][z+kk+7] + Hg*workRsi[r-1][z+kk+8]; moa = 1.5*workRsi[r][z+kk+7] - 0.5 * workRsi[r][z+kk+8];
         }
         if (moa != 0)
              return(MathMax(MathMin((mom/moa+1.0)*50.0,100.00),0.00)); 
         else return(50);
      
      case 3 :
         double sump = 0;
         double sumn = 0;
         for (k=0; k<period; k++)
         {
            double diff = workRsi[r-k][z+_price]-workRsi[r-k-1][z+_price];
               if (diff > 0) sump += diff;
               if (diff < 0) sumn -= diff;
         }
         if (sumn > 0)
               return(100.0-100.0/(1.0+sump/sumn));
         else  return(50);
   } 
}

double workSmma[][2];
double iSmma(double price, double period, int r, int instanceNo=0){
   if (ArrayRange(workSmma,0)!= Bars) ArrayResize(workSmma,Bars);
   if (r<period)
         workSmma[r][instanceNo] = price;
   else  workSmma[r][instanceNo] = workSmma[r-1][instanceNo]+(price-workSmma[r-1][instanceNo])/period;
   return(workSmma[r][instanceNo]);
}

//+-------------------------------------------------------------------
//|       Alerts                                                           
//+-------------------------------------------------------------------

void manageAlerts() {
   if (!calculateValue && alertsOn) {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      
      
      if (trend[whichBar] != trend[whichBar+1]) {
         if (trend[whichBar] ==  1) doAlert(whichBar,"up");
         if (trend[whichBar] == -1) doAlert(whichBar,"down");
      }
   }
}

void doAlert(int forBar, string doWhat) {
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," QQE trend changed to ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"QQE"),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//+------------------------------------------------------------------+
//|   Manage & Draw & Delete Arrows                                                               |
//+------------------------------------------------------------------+
void manageArrow(int i){
   if (ShowArrows){
      deleteArrow(Time[i]);
      if (trend[i]!=trend[i+1]){
         if (trend[i] == 1) drawArrow(i,arrowsUpColor,233,false);
         if (trend[i] ==-1) drawArrow(i,arrowsDnColor,234,true);
      }
   }
}               

//**************************************
void drawArrow(int i,color theColor,int theCode,bool up){
   string name = arrowsIdentifier+":"+Time[i];
   double gap  = 4.0*iATR(NULL,0,20,i)/4.0;   
   ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
      ObjectSet(name,OBJPROP_ARROWCODE,theCode);
      ObjectSet(name,OBJPROP_COLOR,theColor);
      if (up)
            ObjectSet(name,OBJPROP_PRICE1,High[i]+ gap);
      else  ObjectSet(name,OBJPROP_PRICE1,Low[i] - gap);
}

//**************************************
void deleteArrows(){
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--){
      string objectName = ObjectName(i);
      if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}

//**************************************
void deleteArrow(datetime time){
   string lookFor = arrowsIdentifier+":"+time; ObjectDelete(lookFor);
}